#include <iostream>
#include <fstream>
#include <string>
#include <math.h>

using namespace std;

struct RectangleBox
{
      int partNum;
      int candidateNum;
};

int main()
{
   fstream in;

   char fname[100];   
   double part[10][500][6]; // Maximum 500 candidates for each body part
   double pNum[10];
   double h[10];
   double w[10];
   h[0] = 60;
   w[0] = 40;
   h[1] = 40;
   w[1] = 40;
   h[2] = 11/2;
   w[2] = 43/2;
   h[3] = 11/2;
   w[3] = 45/2;
   h[4] = 11/2;
   w[4] = 43/2;
   h[5] = 11/2;
   w[5] = 45/2;
   h[6] = 26/2;
   w[6] = 60/2;
   h[7] = 19/2;
   w[7] = 67/2;
   h[8] = 26/2;
   w[8] = 60/2;
   h[9] = 19/2;
   w[9] = 67/2;

   for (int i = 0; i < 10; i ++)
   {
      sprintf(fname, "part%d.txt", i+1);
      in.open(fname, ios::in);
      int rows;
      in >> rows;
      pNum[i] = rows;
      for (int j = 0; j < rows; j ++)
      {
          int x1, y1, x2, y2;
          double thita, cost;
          in >> x1 >> y1 >> x2 >> y2 >> thita >> cost;
          part[i][j][0] = x1;
          part[i][j][1] = y1;
          part[i][j][2] = x2;
          part[i][j][3] = y2;
          part[i][j][4] = thita;
          part[i][j][5] = cost;
          //cout << x1 << " " << y1  << " " << x2 << " " << y2
          //     << " " << thita << " " << cost << endl;
      }
      in.close();
   }
 
   const int IW = 377;
   const int IH = 365;

   double mask[51][51];
   in.open("mask.txt", ios::in);
 
   int msk_count = 0; 
   for (int i = 1; i <= 50; i ++)
   {
       for (int j = 1; j <= 50; j ++)
       {
          in >> mask[i][j];
          if (mask[i][j] > 0)
             msk_count ++;
       }
   } 
   in.close();

   cout << "Minimize" << endl;
   int cn = 0;
   for (int y = 1; y <= 50; y ++)
   for (int x = 1; x <= 50; x ++)
   {
          if (mask[y][x] > 0)
            cn ++;

          if (mask[y][x] > 0 && cn < msk_count)
             cout <<  "- 20 y" << x << "," << y << endl;
          else if (mask[y][x] > 0 && cn == msk_count)
             cout <<  "- 20 y" << x << "," << y << "+" << endl;
   }
   
   // head not used
   /*for (int i = 0; i < pNum[0]; i ++)
   {
      for (int m = 0; m < pNum[1]; m ++)
      {
             double x1 = part[0][i][0];
             double y1 = part[0][i][1];
             double x2 = part[0][i][2];
             double y2 = part[0][i][3];
             double thita1 = part[0][i][4];
             double cost1 = part[0][i][5];

             double xx1 = part[1][m][0];
             double yy1 = part[1][m][1];
             double xx2 = part[1][m][2];
             double yy2 = part[1][m][3];
             double thita2 = part[1][m][4];
             double cost2 = part[1][m][5];

             double ew = 20*(fabs(x2 - xx1) + fabs(y2 - yy1));
             cout << ew << " w" << 0 << "," << i << "," << 1 << "," << m << " +\n";
      }
   }*/

   for (int k = 2; k <= 8; k += 2)
   for (int i = 0; i < pNum[k]; i ++)
   {
      for (int m = 0; m < pNum[0]; m ++)
      {
             double x1 = part[0][m][0];
             double y1 = part[0][m][1];
             double x2 = part[0][m][2];
             double y2 = part[0][m][3];
             double thita1 = part[0][m][4];
             double cost1 = part[0][m][5];
             
             double ax = x2;
             double ay = y2;

             if (k == 6 || k == 8) 
             {
                 ax = x1;
                 ay = y1;
             }

             double cx = (x1 + x2) / 2;
             double cy = (y1 + y2) / 2;
             double bx = (ax - cx) * cos(-thita1) + (ay - cy) * sin(-thita1) + cx;
             double by = (ax - cx) * sin(thita1) + (ay - cy) * cos(-thita1) + cy;
             if (k == 2)
                   bx = bx - 30;
             else if (k == 4)
                   bx = bx + 30;
             double dx = (bx - cx) * cos(thita1) + (by - cy) * sin(thita1) + cx;
             double dy = (bx - cx) * sin(-thita1) + (by - cy) * cos(thita1) + cy;  
             
             double xx1 = part[k][i][0];
             double yy1 = part[k][i][1];
             double xx2 = part[k][i][2];
             double yy2 = part[k][i][3];
             double thita2 = part[k][i][4];
             double cost2 = part[k][i][5];
             
             double ew = cost1  + cost2 + 3*(fabs(dx - xx1) + fabs(dy - yy1));
               
             cout << ew << " w" << 0 << "," << m << "," << k << "," << i << " +\n";
      }

      for (int n = 0; n < pNum[k+1]; n ++)
      {

             double x1 = part[k][i][0];
             double y1 = part[k][i][1];
             double x2 = part[k][i][2];
             double y2 = part[k][i][3];
             double thita1 = part[k][i][4];
             double cost1 = part[k][i][5];

             double xx1 = part[k+1][n][0];
             double yy1 = part[k+1][n][1];
             double xx2 = part[k+1][n][2];
             double yy2 = part[k+1][n][3];
             double thita2 = part[k+1][n][4];
             double cost2 = part[k+1][n][5];
  
             double dt = sin(thita1/2.0 - thita2/2.0);

             double ew = cost2 + 5*(fabs(x2-xx1) + fabs(y2-yy1)) + 10 * dt * dt;

             //if (fabs(x2-xx1) + fabs(y2-yy1) > 15)
             //    ew = 10000;

             if (fabs(x1-xx1) + fabs(y1-yy1) + fabs(x2-xx2) + fabs(y2-yy2) < 10 ||
                 fabs(x2-xx1) + fabs(y2-yy1) + fabs(x1-xx2) + fabs(y1-yy2) < 10)
                ew = 10000;   

             if (k == 8 && i == pNum[k]-1 && n == pNum[k+1] - 1)
                cout << ew << " w" << k << "," << i << "," << k+1 << "," << n << "\n";
             else
                cout << ew << " w" << k << "," << i << "," << k+1 << "," << n << " +\n";
      }
   }

   cout << "Subject To" << endl;

   // flow condition
   for (int k = 2; k <= 8; k += 2)
   for (int i = 0; i < pNum[k]; i ++)
   { 
      for (int m = 0; m < pNum[0]; m ++)
      {
          if ( m == pNum[0]-1)
             cout << "w" << 0 << "," << m << "," << k << "," << i << " -\n";
          else
             cout << "w" << 0 << "," << m << "," << k << "," << i << " +\n";
      }

      for (int n = 0; n < pNum[k+1]; n ++)
      {
          if ( n == pNum[k+1]-1)
             cout << "w" << k << "," << i << "," << k+1 << "," << n << " = 0\n";
          else
             cout << "w" << k << "," << i << "," << k+1 << "," << n << " -\n";     
      }
   }

   for (int k = 2; k <= 8; k += 2)
   {   
     for (int m = 0; m < pNum[0]; m ++)
     for (int i = 0; i < pNum[k]; i ++)
     {
          if ( i == pNum[k]-1)
             cout << "w" << 0 << "," << m << "," << k << "," << i << " - " 
                  << "xx" << 0 << "," << m << " = 0\n";
          else
             cout << "w" << 0 << "," << m << "," << k << "," << i << " +\n";
     }
   }


   for (int k = 2; k <= 8; k += 2)
   for (int i = 0; i < pNum[k]; i ++)
   { 
      for (int m = 0; m < pNum[0]; m ++)
      {
          if ( m == pNum[0]-1)
             cout << "w" << 0 << "," << m << "," << k << "," << i << " - "
                  << "xx" << k << "," << i << " = 0\n";
          else
             cout << "w" << 0 << "," << m << "," << k << "," << i << " +\n";
      }
   }

   for (int k = 2; k <= 8; k += 2)
   for (int i = 0; i < pNum[k+1]; i ++)
   {
      for (int n = 0; n < pNum[k]; n ++)
      {
          if ( n == pNum[k]-1)
             cout << "w" << k << "," << n << "," << k+1 << "," << i << " - "
                  << "xx" << k + 1 << "," << i << " = 0\n";
          else
             cout << "w" << k << "," << n << "," << k+1 << "," << i << " +\n";
      }
   }

  // for the head
   for (int i = 0; i < pNum[0]; i ++)
   {
      for (int n = 0; n < pNum[1]; n ++)
      {
          if ( n == pNum[1]-1)
             cout << "w" << 0 << "," << i << "," << 1 << "," << n << " - "
                  << "xx" << 0 << "," << i << " = 0\n";
          else
             cout << "w" << 0 << "," << i << "," << 1 << "," << n << " +\n";
      }
   }
   
   for (int i = 0; i < pNum[1]; i ++)
   {
      for (int n = 0; n < pNum[0]; n ++)
      {
          if ( n == pNum[0]-1)
             cout << "w" << 0 << "," << n << "," << 1 << "," << i << " - "
                  << "xx" << 1 << "," << i << " = 0\n";
          else
             cout << "w" << 0 << "," << n << "," << 1 << "," << i << " +\n";       
      }
   }

  // ---------------------------------------------------------------------------           
   
   for (int i = 0; i < 10; i ++)
   {
       for (int j = 0; j < pNum[i]; j ++)
       {
          if (j < pNum[i] - 1)
             cout << "xx" << i << "," << j << " + \n";
          else
             cout << "xx" << i << "," << j << " = 1\n";
       }
   }
   

   RectangleBox overlapBoxes[1000];

   for (int y = 1; y <= 50; y ++)
   for (int x = 1; x <= 50; x ++)
   {

     if (mask[y][x] > 0) 
     {
        double xx = (x - 0.5) * IW/50.0;
        double yy = (y - 0.5) * IH/50.0;
        int overlapNum = 0; 
        for (int i = 0; i < 10; i ++)
        for (int j = 0; j < pNum[i]; j ++)
        {

           double cx = (part[i][j][0] + part[i][j][2])/2;
           double cy = (part[i][j][1] + part[i][j][3])/2;
           double thita = part[i][j][4];

           double px = (xx - cx) * cos(-thita) + (yy - cy) * sin(-thita) + cx;
           double py = (xx - cx) * sin(thita) + (yy - cy) * cos(-thita) + cy;
               
           if (px >= cx - w[i] && px <= cx + w[i] &&
               py >= cy - h[i] && py <= cy + h[i])
           {
              overlapBoxes[overlapNum].partNum = i;
              overlapBoxes[overlapNum].candidateNum = j;              
              overlapNum ++;
           }
               
         }
   
         if (overlapNum > 0)  
         {
            for (int i = 0; i < overlapNum - 1; i ++)
             cout << "xx" << overlapBoxes[i].partNum << "," << overlapBoxes[i].candidateNum  << "+" << endl;

            cout << "xx" << overlapBoxes[overlapNum-1].partNum << "," << overlapBoxes[overlapNum-1].candidateNum
                 << " - y" <<  x << "," << y << " >= 0" << endl;
         }
     }
   }
   
   cout << endl << "Bounds" << endl;
   for (int y = 1; y <= 50; y ++)
   for (int x = 1; x <= 50; x ++)
   {
       if (mask[y][x] > 0)
          cout <<  "0 =<  y" <<  x << "," << y << " <=  1" << endl; 
   }

   cout << endl << "Binaries" << endl;
   for (int i = 0; i < 10; i ++)
   {
       for (int j = 0; j < pNum[i]; j ++)
       {
           cout << "xx" << i << "," << j << "\n";
       }
   }

   cout << "End" << endl;   
 
   return 0;
} 
