function match_template(template, end_points)

msk = imread('mask.bmp');
msk = im2double(msk);
msk_ed = edge(msk, 'canny', 0.1);

im = imread('test.png');
im = rgb2gray(im);
im = im2double(im);
im = edge(im, 'canny', 0.15);
im = (im + msk_ed) > 0;
im = bwdist(im, 'euclidean');
im = im / 255;

ccc = [];
rrr = [];
sss = [];
xy = [];

for nnn = 1 : 36  
 nnn   
angle = (nnn-1)*10;
tpx = imrotate(template, angle);
tpx = flipud(tpx);
tpx = fliplr(tpx);
[h,w] = size(tpx);

thita = pi*angle/180;
T = maketform('affine',[cos(thita) -sin(thita) 0; sin(thita) cos(thita) 0; 0 0 1]);
P = tformfwd(end_points, T);
P = P + repmat([w/2 h/2], 2, 1);

cost = conv2(im, tpx, 'same');

ord = 5;
map_smooth = ordfilt2(cost, 1, ones(ord, ord));

thresh = 10000;
cim = (cost==map_smooth)&(map_smooth<thresh);
[rr,cc] = find(cim);

for n = 1 : length(rr)
     u = cc(n);
     v = rr(n);
     x1 = floor(u - w/2);
     y1 = floor(v - h/2);
     x2 = x1 + w - 1;
     y2 = y1 + h - 1;
     q1 = round(P(1,2) + y1 - 1);
     p1 = round(P(1,1) + x1 - 1);
     q2 = round(P(2,2) + y1 - 1);
     p2 = round(P(2,1) + x1 - 1);

     if p1 > 1 & p1 < size(im,2) & p2 > 1 & p2 < size(im,2) &...
        q1 > 1 & q1 < size(im,1) & q2 > 1 & q2 < size(im,1)
       if msk(v, u) > 0 & msk(q1, p1) > 0 & msk(q2, p2) > 0
          P = floor(P);
          ccc = [ccc, cc(n)];
          rrr = [rrr, rr(n)];
          sss = [sss, map_smooth(rr(n), cc(n))];
          xy = [xy;  P(1,1) + x1 - 1, P(1,2) + y1 - 1,...
                     P(2,1) + x1 - 1, P(2,2) + y1 - 1, thita];
       end
     end

end  
end

imshow(im == 0);
hold on;

pnum = sum(template(:));
[y, ix] = sort(sss);
fd = fopen('match.txt', 'wt');
match_num = min(size(ccc, 2), 200);
fprintf(fd, '%d\n', match_num);
for n = 1 : match_num
  id = ix(n);
  plot(ccc(id), rrr(id), '+');
  plot([xy(id,1), xy(id,3)], [xy(id,2), xy(id,4)]);
  fprintf(fd, '%d %d %d %d %f %f\n', xy(id,1), xy(id,2), xy(id,3), xy(id,4), xy(id,5), sss(id));
end
fclose(fd);

hold off; 
drawnow;
